Index: trunk/SophyaPI/PIext/Makefile
===================================================================
--- trunk/SophyaPI/PIext/Makefile	(revision 1888)
+++ trunk/SophyaPI/PIext/Makefile	(revision 1905)
@@ -58,5 +58,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pidrawer.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -143,5 +145,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pidrawer.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -165,6 +169,5 @@
  $(INC)gp_dynarray.h \
  $(INC)gp_graph3d.h \
- $(INC)gp_alloc.h \
- nomgadapter.h \
+ $(INC)gp_alloc.h nomgadapter.h \
  $(INC)generalfit.h \
  $(INC)tvector.h \
@@ -209,4 +212,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -245,4 +249,5 @@
  $(INC)pifilechogen.h \
  $(INC)piimage.h \
+ $(INC)pieldrw.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -303,5 +308,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pidrawer.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -342,4 +349,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -378,4 +386,5 @@
  $(INC)pifilechogen.h \
  $(INC)piimage.h \
+ $(INC)pieldrw.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -410,5 +419,5 @@
  $(INC)fitslocalmap.h \
  $(INC)localmap.h pitvmaad.h \
- $(INC)piscdrawwdg.h \
+ $(INC)piyfxdrw.h \
  $(INC)pisurfdr.h pipodrw.h \
  $(INC)histos2.h \
@@ -438,4 +447,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -480,4 +490,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -528,4 +539,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -566,5 +578,6 @@
  $(INC)piwindowgen.h \
  $(INC)picontainerx.h \
- $(INC)picontainergen.h pipodrw.h servnobjm.h \
+ $(INC)picontainergen.h \
+ $(INC)pieldrw.h pipodrw.h servnobjm.h \
  $(INC)pdlmgr.h dlftypes.h \
  $(INC)objfitter.h \
@@ -600,4 +613,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -653,4 +667,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -717,4 +732,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -763,4 +779,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -782,13 +799,5 @@
  $(INC)perrors.h \
  $(INC)fmath.h pitvmaad.h \
- $(INC)piscdrawwdg.h \
- $(INC)pibwdgx.h \
- $(INC)pigraphps.h \
- $(INC)pistdwdgx.h \
- $(INC)pistdwdggen.h \
- $(INC)piwindowx.h \
- $(INC)piwindowgen.h \
- $(INC)picontainerx.h \
- $(INC)picontainergen.h \
+ $(INC)piyfxdrw.h \
  $(INC)fioarr.h \
  $(INC)fitstarray.h \
@@ -843,15 +852,8 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
- $(INC)parradapter.h \
- $(INC)lut.h \
- $(INC)piscdrawwdg.h \
- $(INC)pibwdgx.h \
- $(INC)pigraphps.h \
- $(INC)pistdwdgx.h \
- $(INC)pistdwdggen.h \
- $(INC)piwindowx.h \
- $(INC)piwindowgen.h \
- $(INC)picontainerx.h \
- $(INC)picontainergen.h pitvmaad.h \
+ $(INC)pigratt.h \
+ $(INC)parradapter.h \
+ $(INC)lut.h \
+ $(INC)piyfxdrw.h pitvmaad.h \
  $(INC)fitstarray.h \
  $(INC)fitsfile.h \
@@ -900,4 +902,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -925,4 +928,5 @@
  $(INC)pifilechogen.h \
  $(INC)piimage.h \
+ $(INC)pieldrw.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -976,5 +980,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pidrawer.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -1059,4 +1065,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -1082,4 +1089,5 @@
  $(INC)pifilechogen.h \
  $(INC)piimage.h \
+ $(INC)pieldrw.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -1132,5 +1140,6 @@
  $(INC)pigraphuc.h \
  $(INC)pievthandler.h \
- $(INC)psfile.h
+ $(INC)psfile.h \
+ $(INC)pigratt.h
 $(OBJ)pigfd2.o: pigfd2.cc pigfd2.h \
  $(INC)generaldata.h \
@@ -1173,4 +1182,6 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
+ $(INC)pieldrw.h \
  $(INC)pigraph3d.h \
  $(INC)pibwdgx.h \
@@ -1213,9 +1224,9 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)hisprof.h
-$(OBJ)pihisto2d.o: pihisto2d.cc $(INC)piapplgen.h \
- $(INC)pimsghandler.h \
- $(INC)machdefs.h \
- $(INC)pisysdep.h \
+$(OBJ)pihisto2d.o: pihisto2d.cc $(INC)piapplx.h \
+ $(INC)piapplgen.h \
+ $(INC)pimsghandler.h \
  $(INC)picontainerx.h \
  $(INC)picontainergen.h \
@@ -1268,4 +1279,6 @@
  $(INC)piwindowgen.h \
  $(INC)pidrawer.h \
+ $(INC)pigratt.h \
+ $(INC)pieldrw.h \
  $(INC)nbrandom.h \
  $(INC)srandgen.h
@@ -1314,5 +1327,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pidrawer.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -1392,4 +1407,6 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
+ $(INC)pieldrw.h \
  $(INC)pigraph3d.h \
  $(INC)pibwdgx.h \
@@ -1414,5 +1431,6 @@
  $(INC)pigraphuc.h \
  $(INC)pievthandler.h \
- $(INC)psfile.h
+ $(INC)psfile.h \
+ $(INC)pigratt.h
 $(OBJ)pipodrw.o: pipodrw.cc pipodrw.h \
  $(INC)machdefs.h \
@@ -1434,4 +1452,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -1503,5 +1522,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pidrawer.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -1581,5 +1602,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pidrawer.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -1592,14 +1615,9 @@
  $(INC)pistzwin.h \
  $(INC)piperiodx.h \
- $(INC)periodic.h pihisto2d.h \
- $(INC)histos2.h \
- $(INC)peida.h \
- $(INC)utils.h \
- $(INC)fmath.h \
- $(INC)histos.h \
- $(INC)piscdrawwdg.h \
+ $(INC)periodic.h \
  $(INC)piimgtools.h \
  $(INC)pidrwtools.h \
- $(INC)piaxestools.h piinit.h \
+ $(INC)piaxestools.h \
+ $(INC)piscdrawwdg.h piinit.h \
  $(INC)sambainit.h \
  $(INC)skymapinit.h \
@@ -1652,4 +1670,5 @@
  $(INC)pievthandler.h \
  $(INC)psfile.h \
+ $(INC)pigratt.h \
  $(INC)parradapter.h \
  $(INC)lut.h \
@@ -1688,4 +1707,5 @@
  $(INC)pifilechogen.h \
  $(INC)piimage.h \
+ $(INC)pieldrw.h \
  $(INC)pipixmapx.h \
  $(INC)pipixmapgen.h \
@@ -1706,5 +1726,5 @@
  $(INC)histos2.h \
  $(INC)hisprof.h \
- $(INC)piscdrawwdg.h \
+ $(INC)piyfxdrw.h \
  $(INC)pisurfdr.h pintuple.h pintup3d.h \
  pipodrw.h
Index: trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/nobjmgr.cc	(revision 1905)
@@ -26,5 +26,5 @@
 #include "tvector.h"
 #include "pitvmaad.h"
-#include "piscdrawwdg.h"
+#include "piyfxdrw.h"
 #endif
 
Index: trunk/SophyaPI/PIext/nommatvecadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nommatvecadapter.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/nommatvecadapter.cc	(revision 1905)
@@ -6,5 +6,5 @@
 
 #include "nommatvecadapter.h"
-#include "piscdrawwdg.h"
+#include "piyfxdrw.h"
 #include "pipodrw.h"
 
Index: trunk/SophyaPI/PIext/nomtarradapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 1905)
@@ -11,5 +11,5 @@
 #include "tvector.h"
 #include "pitvmaad.h"
-#include "piscdrawwdg.h"
+#include "piyfxdrw.h"
 
 #include "fioarr.h"
Index: trunk/SophyaPI/PIext/nomtmatvecadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 1905)
@@ -11,5 +11,5 @@
 #include "objfitter.h"
 #include "nomtmatvecadapter.h"
-#include "piscdrawwdg.h"
+#include "piyfxdrw.h"
 #include "pitvmaad.h"
 
Index: trunk/SophyaPI/PIext/pigfd1.cc
===================================================================
--- trunk/SophyaPI/PIext/pigfd1.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/pigfd1.cc	(revision 1905)
@@ -60,5 +60,5 @@
 if(VarX<0) return;
 // On plotte les barre d'erreurs ligne demandee explicitement
-if(mLAtt!=PI_NotDefLineAtt) SelectErrBar(true,true);
+if(GetGraphicAtt().GetLineAtt()!=PI_NotDefLineAtt) SelectErrBar(true,true);
 double xp,yp,er;
 for (int i=0; i<mGFD->NData(); i++) {
Index: trunk/SophyaPI/PIext/pigfd2.cc
===================================================================
--- trunk/SophyaPI/PIext/pigfd2.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/pigfd2.cc	(revision 1905)
@@ -73,5 +73,5 @@
 
 // On plotte les barre d'erreurs ligne demandee explicitement
-if(mLAtt!=PI_NotDefLineAtt) SelectErrBar(true,true,true);
+if(GetGraphicAtt().GetLineAtt()!=PI_NotDefLineAtt) SelectErrBar(true,true,true);
 
 #if defined(CC_HAS_RTTI_SUPPORT)
@@ -81,5 +81,5 @@
 #endif
 
-if (mLAtt == PI_NotDefLineAtt)  g3->SelLine(PI_ThinLine);
+if (GetGraphicAtt().GetLineAtt() == PI_NotDefLineAtt)  g3->SelLine(PI_ThinLine);
 
 double xp,yp,zp,er;
Index: trunk/SophyaPI/PIext/pihisto.cc
===================================================================
--- trunk/SophyaPI/PIext/pihisto.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/pihisto.cc	(revision 1905)
@@ -77,8 +77,9 @@
   if (!mHisto)  return;  
 
-  if(mMrk != PI_NotDefMarker ||  (typeid(*mHisto) == typeid(HProf)) ) {
+  if((GetGraphicAtt().GetMarker() != PI_NotDefMarker) ||  
+     (typeid(*mHisto) == typeid(HProf)) ) {
     // Marqeurs definis OU HProf => marqueurs+Erreurs si il y en a
     mHisto->UpdateHisto(); // pour le cas ou c'est un HProf
-    if(mLAtt == PI_NotDefLineAtt) g->SelLine(PI_ThinLine);
+    if(GetGraphicAtt().GetLineAtt() == PI_NotDefLineAtt) g->SelLine(PI_ThinLine);
     double x1,y1, x2,y2;
     double bw = mHisto->BinWidth();
@@ -102,5 +103,5 @@
     oktrace = true;
   }
-  if(mLAtt != PI_NotDefLineAtt) {
+  if(GetGraphicAtt().GetLineAtt() != PI_NotDefLineAtt) {
     double x1,y1, x2, y2;
     x1 = mHisto->BinLowEdge(0);
@@ -138,5 +139,5 @@
   //  if (mLAtt == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
   g->SelLine(PI_ThinLine);
-  g->SelFontSz((YMax() - YMin())/30, mFAtt);
+  g->SelFontSz((YMax() - YMin())/30);
 
   // La hauteur de la cellule
Index: trunk/SophyaPI/PIext/pihisto2d.cc
===================================================================
--- trunk/SophyaPI/PIext/pihisto2d.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/pihisto2d.cc	(revision 1905)
@@ -253,5 +253,5 @@
 
 // gestion epaisseur de ligne
-if (mLAtt == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
+if (GetGraphicAtt().GetLineAtt() == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
 
 // gestion Markers ou plot avec des points.
@@ -389,6 +389,6 @@
 {
   if (!mHisto) return;
-  if (mLAtt == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
-  g->SelFontSz((YMax() - YMin())/30, mFAtt);
+  if (GetGraphicAtt().GetLineAtt() == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
+  g->SelFontSz((YMax() - YMin())/30);
 
   // La hauteur de la cellule
Index: trunk/SophyaPI/PIext/pintup3d.cc
===================================================================
--- trunk/SophyaPI/PIext/pintup3d.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/pintup3d.cc	(revision 1905)
@@ -179,5 +179,5 @@
 #endif
 
-if (mLAtt == PI_NotDefLineAtt)  g3->SelLine(PI_ThinLine);
+if (GetGraphicAtt().GetLineAtt() == PI_NotDefLineAtt)  g3->SelLine(PI_ThinLine);
 
 //  Pour tracer des markers avec taille fonction de Wt (poids)
@@ -186,8 +186,9 @@
 int msz,sz;
 
+PIMarker mmrk = GetGraphicAtt().GetMarker();
 PIMarker mrk;
-if (wK >= 0)  mrk = (mMrk != PI_NotDefMarker) ? mMrk : PI_CircleMarker;
-else   mrk = (mMrk != PI_NotDefMarker) ? mMrk : PI_DotMarker;
-msz = mMSz;
+if (wK >= 0)  mrk = (mmrk != PI_NotDefMarker) ? mmrk : PI_CircleMarker;
+else   mrk = (mmrk != PI_NotDefMarker) ? mmrk : PI_DotMarker;
+msz = GetGraphicAtt().GetMarkerSz();
 if (msz < 1) msz = 1;
 g->SelMarker(msz, mrk);
@@ -200,5 +201,6 @@
   yp = mNT->GetCell(i, yK);
   zp = mNT->GetCell(i, zK);
-  if ( (i > 0) && (mLAtt != PI_NotDefLineAtt) )   // On relie les points ...
+  if ( (i > 0) && 
+       (GetGraphicAtt().GetLineAtt() != PI_NotDefLineAtt) )   // On relie les points ...
     g3->DrawLine3D(xl, yl, zl, xp, yp, zp);
   nok++;
@@ -225,5 +227,5 @@
   }
   // Trace du marker
-  if ((wK >= 0)||(lK < 0)||(mMrk != PI_NotDefMarker))  g3->DrawMarker3D(xp, yp, zp); 
+  if ((wK >= 0)||(lK < 0)||(mmrk != PI_NotDefMarker))  g3->DrawMarker3D(xp, yp, zp); 
   // Trace eventuel du label
   if (lK >= 0) g3->DrawString3D(xp, yp, zp, mNT->GetCelltoString(i, lK).c_str());
Index: trunk/SophyaPI/PIext/pintuple.cc
===================================================================
--- trunk/SophyaPI/PIext/pintuple.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/pintuple.cc	(revision 1905)
@@ -149,5 +149,5 @@
 if (axesFlags != kAxesNone) DrawAxes(g);
 if ( (xK < 0) || (yK < 0) )  return;
-if (mLAtt == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
+if (GetGraphicAtt().GetLineAtt() == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
 
 //  Pour tracer des markers avec taille fonction de Wt (poids)
@@ -156,8 +156,9 @@
 int msz,sz;
 
+PIMarker mmrk = GetGraphicAtt().GetMarker();
 PIMarker mrk;
-if (wK >= 0)  mrk = (mMrk != PI_NotDefMarker) ? mMrk : PI_CircleMarker;
-else   mrk = (mMrk != PI_NotDefMarker) ? mMrk : PI_DotMarker;
-msz = mMSz;
+if (wK >= 0)  mrk = (mmrk != PI_NotDefMarker) ? mmrk : PI_CircleMarker;
+else   mrk = (mmrk != PI_NotDefMarker) ? mmrk : PI_DotMarker;
+msz = GetGraphicAtt().GetMarkerSz();;
 if (msz < 1) msz = 1;
 g->SelMarker(msz, mrk);
@@ -179,6 +180,6 @@
   nok++;
   if ( (xp < xmin) || (xp > xmax) || (yp < ymin) || (yp > ymax) )  continue;
-  if ( (i > 0) && (mLAtt != PI_NotDefLineAtt) )   // On relie les points ...
-    g->DrawLine(xl, yl, xp, yp);
+  if ( (i > 0) && (GetGraphicAtt().GetLineAtt() != PI_NotDefLineAtt) )   
+    g->DrawLine(xl, yl, xp, yp);  // On relie les points ...
   if ( xebK >= 0 ) {
     xer = mNT->GetCell(i, xebK);
@@ -199,5 +200,5 @@
   }
   // Trace du marker
-  if ((wK >= 0)||(lK < 0)||(mMrk != PI_NotDefMarker))  g->DrawMarker(xp, yp); 
+  if ((wK >= 0)||(lK < 0)||(mmrk != PI_NotDefMarker))  g->DrawMarker(xp, yp); 
   // Trace eventuel du label
   if (lK >= 0) g->DrawString(xp, yp, mNT->GetCelltoString(i, lK).c_str());
@@ -206,5 +207,5 @@
 
 if (stats) { // Trace de stats 
-  g->SelFontSz((YMax() - YMin())/30, mFAtt);  
+  g->SelFontSz((YMax() - YMin())/30);  
   // La hauteur de la cellule
   PIGrCoord a,d;
Index: trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 1905)
@@ -523,10 +523,14 @@
 
 // Changement d'attributs graphiques courants du drawer
-if (mFCol != PI_NotDefColor) scd->SetColAtt(mFCol, mBCol);
-if (mLAtt != PI_NotDefLineAtt) scd->SetLineAtt(mLAtt);
-if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) scd->SetFontAtt(mFSz, mFAtt); 
-if ( mFName != PI_DefaultFont ) scd->SetFont(mFName, scd->GetFontSz(), scd->GetFontAtt());
-if ( (mMrk != PI_NotDefMarker) && (mMSz >= 0) ) scd->SetMarkerAtt(mMSz, mMrk);
-if ( mCmapid != CMAP_OTHER ) scd->SetColMapId(mCmapid);
+if (mFCol != PI_NotDefColor) scd->GetGraphicAtt().SetColAtt(mFCol, mBCol);
+if (mLAtt != PI_NotDefLineAtt) scd->GetGraphicAtt().SetLineAtt(mLAtt);
+if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) 
+  scd->GetGraphicAtt().SetFontAtt(mFSz, mFAtt); 
+if ( mFName != PI_DefaultFont ) 
+  scd->GetGraphicAtt().SetFontAtt(mFName, scd->GetGraphicAtt().GetFontSz(), 
+			       scd->GetGraphicAtt().GetFontAtt());
+if ( (mMrk != PI_NotDefMarker) && (mMSz >= 0) ) 
+  scd->GetGraphicAtt().SetMarkerAtt(mMSz, mMrk);
+if ( mCmapid != CMAP_OTHER ) scd->GetGraphicAtt().SetColMapId(mCmapid);
 
 
@@ -576,5 +580,5 @@
 scw->SetAxesFlags(mAxesFlags);
 // Fonte de trace d'axe
-scw->BaseDrawer()->SetFont(mFName, mFSz, mFAtt);
+scw->BaseDrawer()->GetGraphicAtt().SetFontAtt(mFName, mFSz, mFAtt);
 /*
 if (typeid(*scd) != typeid(PIHisto2D)) 
@@ -607,10 +611,14 @@
 
 // Changement d'attributs graphiques courants du drawer
-if (mFCol != PI_NotDefColor) dr3->SetColAtt(mFCol, mBCol);
-if (mLAtt != PI_NotDefLineAtt) dr3->SetLineAtt(mLAtt);
-if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) dr3->SetFontAtt(mFSz, mFAtt); 
-if ( mFName != PI_DefaultFont ) dr3->SetFont(mFName, dr3->GetFontSz(), dr3->GetFontAtt());
-if ( (mMrk != PI_NotDefMarker) && (mMSz >= 0) ) dr3->SetMarkerAtt(mMSz, mMrk);
-if ( mCmapid != CMAP_OTHER ) dr3->SetColMapId(mCmapid);
+if (mFCol != PI_NotDefColor) dr3->GetGraphicAtt().SetColAtt(mFCol, mBCol);
+if (mLAtt != PI_NotDefLineAtt) dr3->GetGraphicAtt().SetLineAtt(mLAtt);
+if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) 
+  dr3->GetGraphicAtt().SetFontAtt(mFSz, mFAtt); 
+if ( mFName != PI_DefaultFont ) 
+  dr3->GetGraphicAtt().SetFontAtt(mFName, dr3->GetGraphicAtt().GetFontSz(), 
+				  dr3->GetGraphicAtt().GetFontAtt());
+if ( (mMrk != PI_NotDefMarker) && (mMSz >= 0) ) 
+  dr3->GetGraphicAtt().SetMarkerAtt(mMSz, mMrk);
+if ( mCmapid != CMAP_OTHER ) dr3->GetGraphicAtt().SetColMapId(mCmapid);
 
 if ( (!mLastWdg) && ( (opt == Disp_Same) || (opt == Disp_Inset) ) )  opt = Disp_Next;
@@ -669,7 +677,8 @@
 
 if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) 
-  eld->SetFontAtt(mFSz, mFAtt); 
+  eld->GetGraphicAtt().SetFontAtt(mFSz, mFAtt); 
 if ( mFName != PI_DefaultFont ) 
-  eld->SetFont(mFName, eld->GetFontSz(), eld->GetFontAtt());
+  eld->GetGraphicAtt().SetFontAtt(mFName, eld->GetGraphicAtt().GetFontSz(), 
+				  eld->GetGraphicAtt().GetFontAtt());
 eld->ElAddText(xp,yp,txt.c_str(),mFCol);
 eld->Refresh();
@@ -729,7 +738,8 @@
 
 if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) 
-  eld->SetFontAtt(mFSz, mFAtt); 
+  eld->GetGraphicAtt().SetFontAtt(mFSz, mFAtt); 
 if ( mFName != PI_DefaultFont ) 
-  eld->SetFont(mFName, eld->GetFontSz(), eld->GetFontAtt());
+  eld->GetGraphicAtt().SetFontAtt(mFName, eld->GetGraphicAtt().GetFontSz(), 
+				  eld->GetGraphicAtt().GetFontAtt());
 eld->SetTitles(titletop, titlebottom);
 eld->Refresh();
Index: trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.cc	(revision 1888)
+++ trunk/SophyaPI/PIext/servnobjm.cc	(revision 1905)
@@ -36,5 +36,5 @@
 #include "hisprof.h"
 
-#include "piscdrawwdg.h"
+#include "piyfxdrw.h"
 #include "pisurfdr.h"
 
@@ -1591,13 +1591,16 @@
 gi.a1 = PI_BoldItalicFont;
 GrAfonts["smallbolditalicfont"] = gi;
-gi.a2 = PI_BigSizeFont;
+gi.a2 = PI_LargeSizeFont;
 gi.a1 = PI_RomanFont;
 GrAfonts["bigfont"] = gi;
+GrAfonts["largefont"] = gi;
 gi.a1 = PI_BoldFont;
 GrAfonts["bigboldfont"] = gi;
 gi.a1 = PI_ItalicFont;
 GrAfonts["bigitalicfont"] = gi;
+GrAfonts["largeitalicfont"] = gi;
 gi.a1 = PI_BoldItalicFont;
 GrAfonts["bigbolditalicfont"] = gi;
+GrAfonts["largebolditalicfont"] = gi;
 gi.a2 = PI_HugeSizeFont;
 gi.a1 = PI_RomanFont;