Index: /trunk/SophyaPI/PI/Tests/pist.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/pist.cc	(revision 1907)
+++ /trunk/SophyaPI/PI/Tests/pist.cc	(revision 1908)
@@ -107,5 +107,5 @@
 PIFontAtt att[4] = { PI_RomanFont, PI_BoldFont, PI_ItalicFont, PI_BoldItalicFont};
 PIFontSize fsz[5] = { PI_TinySizeFont, PI_SmallSizeFont, PI_NormalSizeFont, 
-		      PI_BigSizeFont, PI_HugeSizeFont };
+		      PI_LargeSizeFont, PI_HugeSizeFont };
 PIFontName fn[4] = { PI_CourierFont, PI_HelveticaFont, 
 		     PI_TimesFont, PI_SymbolFont};
@@ -114,5 +114,5 @@
 char * attstr[4] = { "RomanFont" , "BoldFont", "ItalicFont", "BoldItalicFont"};
 char * fszstr[5] = { "TinySizeFont", "SmallSizeFont", "NormalSizeFont", 
-		      "BigSizeFont", "HugeSizeFont" };
+		      "LargeSizeFont", "HugeSizeFont" };
 
 if (g->kind() != PI_PSFileGraphics ) EraseWindow();
@@ -246,5 +246,5 @@
    break;
  case '4':
-   mFSize = PI_BigSizeFont;
+   mFSize = PI_LargeSizeFont;
    break;
  case '5':
@@ -289,5 +289,5 @@
 PIFontAtt att[4] = { PI_RomanFont, PI_BoldFont, PI_ItalicFont, PI_BoldItalicFont};
 PIFontSize fsz[5] = { PI_TinySizeFont, PI_SmallSizeFont, PI_NormalSizeFont, 
-		      PI_BigSizeFont, PI_HugeSizeFont };
+		      PI_LargeSizeFont, PI_HugeSizeFont };
 PIFontName fn[4] = { PI_CourierFont, PI_HelveticaFont, 
 		     PI_TimesFont, PI_SymbolFont};
@@ -296,5 +296,5 @@
 char * attstr[4] = { "RomanFont" , "BoldFont", "ItalicFont", "BoldItalicFont"};
 char * fszstr[5] = { "TinySizeFont", "SmallSizeFont", "NormalSizeFont", 
-		      "BigSizeFont", "HugeSizeFont" };
+		      "LargeSizeFont", "HugeSizeFont" };
 
 if (g->kind() != PI_PSFileGraphics ) EraseWindow();
@@ -573,5 +573,5 @@
 PIFontAtt att[4] = { PI_RomanFont, PI_BoldFont, PI_ItalicFont, PI_BoldItalicFont};
 PIFontSize fsz[5] = { PI_TinySizeFont, PI_SmallSizeFont, PI_NormalSizeFont, 
-		      PI_BigSizeFont, PI_HugeSizeFont };
+		      PI_LargeSizeFont, PI_HugeSizeFont };
 PIFontName fn[4] = { PI_CourierFont, PI_HelveticaFont, 
 		     PI_TimesFont, PI_SymbolFont};
@@ -580,5 +580,5 @@
 char * attstr[4] = { "RomanFont" , "BoldFont", "ItalicFont", "BoldItalicFont"};
 char * fszstr[5] = { "TinySizeFont", "SmallSizeFont", "NormalSizeFont", 
-		      "BigSizeFont", "HugeSizeFont" };
+		      "LargeSizeFont", "HugeSizeFont" };
 
 if (g->kind() != PI_PSFileGraphics ) EraseWindow();
Index: /trunk/SophyaPI/PI/Tests/pitgr.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/pitgr.cc	(revision 1907)
+++ /trunk/SophyaPI/PI/Tests/pitgr.cc	(revision 1908)
@@ -16,4 +16,5 @@
 #include "pidrawwin.h"
 #include "piscdrawwdg.h"
+#include "piyfxdrw.h"
 #include "piimage.h"
 #include "parradapter.h"
@@ -178,6 +179,6 @@
 
       PIFuncDrawer* mfd = new PIFuncDrawer(fsinc);
-      mfd->SetColAtt(PI_Gold);
-      mfd->SetLineAtt(PI_NormalLine);
+      mfd->GetGraphicAtt().SetColAtt(PI_Gold);
+      mfd->GetGraphicAtt().SetLineAtt(PI_NormalLine);
       nbwin++; sprintf(strg,"2D Graphics (PI W %d)", nbwin);
       PIWindow* wp = new PIWindow(this, strg, PIWK_normal,  300, 300, 150, 150);
@@ -206,6 +207,6 @@
       PIYfXDrawer* mxyd = new   PIYfXDrawer( new P1DAdapter<float>(vpx, 30, true), 
                                             new P1DAdapter<float>(vpy, 30, true), true); 
-      mxyd->SetColAtt(PI_Red);
-      mxyd->SetMarkerAtt(7, PI_FTriangleMarker);
+      mxyd->GetGraphicAtt().SetColAtt(PI_Red);
+      mxyd->GetGraphicAtt().SetMarkerAtt(7, PI_FTriangleMarker);
 
       nbwin++; sprintf(strg,"2D Graphics (PI W %d)", nbwin);
@@ -233,10 +234,10 @@
                                              new P1DAdapter<float>(vpy, 30, true), true); 
 
-      mxyd->SetColAtt(PI_Magenta);
-      mxyd->SetMarkerAtt(7, PI_FBoxMarker);
+      mxyd->GetGraphicAtt().SetColAtt(PI_Magenta);
+      mxyd->GetGraphicAtt().SetMarkerAtt(7, PI_FBoxMarker);
 
       PIFuncDrawer* mfd = new PIFuncDrawer(fsinc);
-      mfd->SetColAtt(PI_Blue);
-      mfd->SetLineAtt(PI_NormalLine);
+      mfd->GetGraphicAtt().SetColAtt(PI_Blue);
+      mfd->GetGraphicAtt().SetLineAtt(PI_NormalLine);
 
       nbwin++; sprintf(strg,"2D Graphics (PI W %d)", nbwin);
@@ -361,7 +362,7 @@
       PIWindow* awp = new PIWindow(this, strg, PIWK_normal, 500, 500, 200, 200);
       PISurfaceDrawer* sd = new PISurfaceDrawer(new P2DAdapter<float>(tf, 50, 50, true), true, true, true);
-      if (fgswcol%3 == 0) sd->SetColMapId(CMAP_COLRJ32);
-      else if (fgswcol%3 == 1) sd->SetColMapId(CMAP_COLBR32);
-      else sd->SetColMapId(CMAP_COLRV32);
+      if (fgswcol%3 == 0) sd->GetGraphicAtt().SetColMapId(CMAP_COLRJ32);
+      else if (fgswcol%3 == 1) sd->GetGraphicAtt().SetColMapId(CMAP_COLBR32);
+      else sd->GetGraphicAtt().SetColMapId(CMAP_COLRV32);
       fgswcol++;
       PIDraw3DWdg* drw3 = new PIDraw3DWdg(awp, "ex3ddrw", 600, 600, 0, 0);