Index: trunk/SophyaPI/PIext/Makefile
===================================================================
--- trunk/SophyaPI/PIext/Makefile	(revision 1920)
+++ trunk/SophyaPI/PIext/Makefile	(revision 1923)
@@ -4,5 +4,5 @@
  
 all: $(LIB)libPIext.a
-$(LIB)libPIext.a : $(OBJ)basexecut.o $(OBJ)contmodex.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
+$(LIB)libPIext.a : $(OBJ)basexecut.o $(OBJ)contmodex.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)flowmodex.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)pi2dvec.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
 	$(AR) $(ARFLAGS)  $@ $($(ARARGS)) 
 ifeq ($(CXX),cxx)
@@ -11,5 +11,5 @@
  
 clean:
-	rm -f $(OBJ)basexecut.o $(OBJ)contmodex.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
+	rm -f $(OBJ)basexecut.o $(OBJ)contmodex.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)flowmodex.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)pi2dvec.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
 ifeq ($(CXX),cxx)
 	cd $(REPM); rm -f *.o
@@ -18,6 +18,6 @@
 $(OBJ)basexecut.o: basexecut.cc piacmd.h \
  $(INC)machdefs.h dlftypes.h \
- $(INC)pdlmgr.h basexecut.h \
- $(INC)ctimer.h pistdimgapp.h \
+ $(INC)pdlmgr.h \
+ $(INC)ctimer.h basexecut.h pistdimgapp.h \
  $(INC)pisysdep.h \
  $(INC)piapplx.h \
@@ -97,5 +97,6 @@
 $(OBJ)contmodex.o: contmodex.cc contmodex.h \
  $(INC)machdefs.h piacmd.h dlftypes.h \
- $(INC)pdlmgr.h nobjmgr.h \
+ $(INC)pdlmgr.h \
+ $(INC)ctimer.h nobjmgr.h \
  $(INC)anydataobj.h \
  $(INC)ppersist.h \
@@ -185,5 +186,6 @@
 $(OBJ)cxxexecutor.o: cxxexecutor.cc cxxexecutor.h \
  $(INC)machdefs.h piacmd.h dlftypes.h \
- $(INC)pdlmgr.h nobjmgr.h \
+ $(INC)pdlmgr.h \
+ $(INC)ctimer.h nobjmgr.h \
  $(INC)anydataobj.h \
  $(INC)ppersist.h \
@@ -262,5 +264,6 @@
 $(OBJ)cxxexecwin.o: cxxexecwin.cc cxxexecutor.h \
  $(INC)machdefs.h piacmd.h dlftypes.h \
- $(INC)pdlmgr.h nobjmgr.h \
+ $(INC)pdlmgr.h \
+ $(INC)ctimer.h nobjmgr.h \
  $(INC)anydataobj.h \
  $(INC)ppersist.h \
@@ -321,4 +324,82 @@
  $(INC)piperiodx.h \
  $(INC)periodic.h
+$(OBJ)flowmodex.o: flowmodex.cc flowmodex.h \
+ $(INC)machdefs.h piacmd.h dlftypes.h \
+ $(INC)pdlmgr.h \
+ $(INC)ctimer.h nobjmgr.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h pi2dvec.h pistdimgapp.h \
+ $(INC)pisysdep.h \
+ $(INC)piapplx.h \
+ $(INC)piapplgen.h \
+ $(INC)pimsghandler.h \
+ $(INC)picontainerx.h \
+ $(INC)picontainergen.h \
+ $(INC)piwdgx.h \
+ $(INC)piwdggen.h \
+ $(INC)picolist.h \
+ $(INC)pimenubarx.h \
+ $(INC)pimenubargen.h \
+ $(INC)pimenux.h \
+ $(INC)pimenugen.h \
+ $(INC)picons.h \
+ $(INC)pistdwdgx.h \
+ $(INC)pistdwdggen.h \
+ $(INC)pibwdgx.h \
+ $(INC)pibwdggen.h \
+ $(INC)picmap.h \
+ $(INC)picmapx.h \
+ $(INC)picmapgen.h \
+ $(INC)pigraphx.h \
+ $(INC)pigraphgen.h \
+ $(INC)pifontx.h \
+ $(INC)pifontgen.h \
+ $(INC)pigraphuc.h \
+ $(INC)pievthandler.h \
+ $(INC)psfile.h \
+ $(INC)pigraphps.h \
+ $(INC)piwindowx.h \
+ $(INC)piwindowgen.h \
+ $(INC)pioptmenux.h \
+ $(INC)pioptmenugen.h \
+ $(INC)pifilechox.h \
+ $(INC)pifilechogen.h \
+ $(INC)piimage.h \
+ $(INC)parradapter.h \
+ $(INC)lut.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
+ $(INC)pipixmapx.h \
+ $(INC)pipixmapgen.h \
+ $(INC)picmapview.h \
+ $(INC)pi3ddrw.h \
+ $(INC)pigraph3d.h pisiadw.h \
+ $(INC)pilistx.h \
+ $(INC)pilistgen.h \
+ $(INC)pistzwin.h \
+ $(INC)piperiodx.h \
+ $(INC)periodic.h \
+ $(INC)piscdrawwdg.h \
+ $(INC)ntupintf.h \
+ $(INC)ntuple.h nomgadapter.h \
+ $(INC)generalfit.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)generaldata.h \
+ $(INC)poly.h \
+ $(INC)peida.h \
+ $(INC)utils.h \
+ $(INC)perrors.h \
+ $(INC)fmath.h servnobjm.h
 $(OBJ)nobjmgr.o: nobjmgr.cc $(INC)strutil.h \
  $(INC)datatypes.h \
@@ -391,5 +472,6 @@
  $(INC)picmapview.h \
  $(INC)pi3ddrw.h \
- $(INC)pigraph3d.h piacmd.h pisiadw.h \
+ $(INC)pigraph3d.h piacmd.h \
+ $(INC)ctimer.h pisiadw.h \
  $(INC)pilistx.h \
  $(INC)pilistgen.h \
@@ -884,6 +966,7 @@
  $(INC)ntuple.h \
  $(INC)ntupintf.h pawexecut.h piacmd.h \
- dlftypes.h $(INC)pdlmgr.h nobjmgr.h \
- servnobjm.h nomgadapter.h $(INC)pidrawer.h \
+ dlftypes.h $(INC)pdlmgr.h \
+ $(INC)ctimer.h nobjmgr.h servnobjm.h \
+ nomgadapter.h $(INC)pidrawer.h \
  $(INC)pibwdggen.h \
  $(INC)pisysdep.h \
@@ -939,7 +1022,26 @@
  $(INC)piperiodx.h \
  $(INC)periodic.h
-$(OBJ)piacmd.o: piacmd.cc piacmd.h $(INC)machdefs.h \
- dlftypes.h $(INC)pdlmgr.h basexecut.h \
- $(INC)ctimer.h pistdimgapp.h \
+$(OBJ)pi2dvec.o: pi2dvec.cc $(INC)machdefs.h \
+ $(INC)histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)peida.h \
+ $(INC)utils.h \
+ $(INC)perrors.h \
+ $(INC)fmath.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)ntuple.h \
+ $(INC)ntupintf.h \
+ $(INC)nbtri.h pi2dvec.h pistdimgapp.h \
  $(INC)pisysdep.h \
  $(INC)piapplx.h \
@@ -987,4 +1089,61 @@
  $(INC)picmapview.h \
  $(INC)pi3ddrw.h \
+ $(INC)pigraph3d.h nobjmgr.h dlftypes.h \
+ piacmd.h $(INC)pdlmgr.h \
+ $(INC)ctimer.h pisiadw.h \
+ $(INC)pilistx.h \
+ $(INC)pilistgen.h \
+ $(INC)pistzwin.h \
+ $(INC)piperiodx.h \
+ $(INC)periodic.h \
+ $(INC)piscdrawwdg.h
+$(OBJ)piacmd.o: piacmd.cc piacmd.h $(INC)machdefs.h \
+ dlftypes.h $(INC)pdlmgr.h \
+ $(INC)ctimer.h basexecut.h pistdimgapp.h \
+ $(INC)pisysdep.h \
+ $(INC)piapplx.h \
+ $(INC)piapplgen.h \
+ $(INC)pimsghandler.h \
+ $(INC)picontainerx.h \
+ $(INC)picontainergen.h \
+ $(INC)piwdgx.h \
+ $(INC)piwdggen.h \
+ $(INC)picolist.h \
+ $(INC)pimenubarx.h \
+ $(INC)pimenubargen.h \
+ $(INC)pimenux.h \
+ $(INC)pimenugen.h \
+ $(INC)picons.h \
+ $(INC)pistdwdgx.h \
+ $(INC)pistdwdggen.h \
+ $(INC)pibwdgx.h \
+ $(INC)pibwdggen.h \
+ $(INC)picmap.h \
+ $(INC)picmapx.h \
+ $(INC)picmapgen.h \
+ $(INC)pigraphx.h \
+ $(INC)pigraphgen.h \
+ $(INC)pifontx.h \
+ $(INC)pifontgen.h \
+ $(INC)pigraphuc.h \
+ $(INC)pievthandler.h \
+ $(INC)psfile.h \
+ $(INC)pigraphps.h \
+ $(INC)piwindowx.h \
+ $(INC)piwindowgen.h \
+ $(INC)pioptmenux.h \
+ $(INC)pioptmenugen.h \
+ $(INC)pifilechox.h \
+ $(INC)pifilechogen.h \
+ $(INC)piimage.h \
+ $(INC)parradapter.h \
+ $(INC)lut.h \
+ $(INC)pieldrw.h \
+ $(INC)pidrawer.h \
+ $(INC)pigratt.h \
+ $(INC)pipixmapx.h \
+ $(INC)pipixmapgen.h \
+ $(INC)picmapview.h \
+ $(INC)pi3ddrw.h \
  $(INC)pigraph3d.h nobjmgr.h \
  $(INC)anydataobj.h \
@@ -1014,5 +1173,5 @@
  $(INC)perrors.h \
  $(INC)fmath.h pawexecut.h cxxexecutor.h \
- cxxexecwin.h contmodex.h
+ cxxexecwin.h contmodex.h flowmodex.h
 $(OBJ)piafitting.o: piafitting.cc $(INC)strutil.h \
  $(INC)nbtri.h \
@@ -1068,6 +1227,7 @@
  $(INC)parradapter.h \
  $(INC)lut.h \
- $(INC)pdlmgr.h dlftypes.h piacmd.h nobjmgr.h \
- pistdimgapp.h $(INC)piapplx.h \
+ $(INC)pdlmgr.h dlftypes.h piacmd.h \
+ $(INC)ctimer.h nobjmgr.h pistdimgapp.h \
+ $(INC)piapplx.h \
  $(INC)piapplgen.h \
  $(INC)picontainerx.h \
@@ -1342,5 +1502,6 @@
  $(INC)objfio.h \
  $(INC)mutyv.h dlftypes.h piacmd.h \
- $(INC)pdlmgr.h pisiadw.h \
+ $(INC)pdlmgr.h \
+ $(INC)ctimer.h pisiadw.h \
  $(INC)pilistx.h \
  $(INC)pilistgen.h \
@@ -1712,5 +1873,6 @@
  $(INC)picmapview.h \
  $(INC)pi3ddrw.h \
- $(INC)pigraph3d.h piacmd.h pisiadw.h \
+ $(INC)pigraph3d.h piacmd.h \
+ $(INC)ctimer.h pisiadw.h \
  $(INC)pilistx.h \
  $(INC)pilistgen.h \
Index: trunk/SophyaPI/PIext/objlist.list
===================================================================
--- trunk/SophyaPI/PIext/objlist.list	(revision 1920)
+++ trunk/SophyaPI/PIext/objlist.list	(revision 1923)
@@ -3,4 +3,5 @@
 cxxexecutor.o
 cxxexecwin.o
+flowmodex.o
 nobjmgr.o
 nomgadapter.o
@@ -13,4 +14,5 @@
 nomtmatvecadapter.o
 pawexecut.o
+pi2dvec.o
 piacmd.o
 piafitting.o